<?
	require('config.inc.php');
	require('db.inc.php');
	require('tools.inc.php');

	$time = localtime(time(), TRUE);

	$hour = $time['tm_hour'];
	$weekday = $time['tm_wday'];
	$monthday = $time['tm_mday'];

	$field = 'day';

	$last_n = 5;
	if ($_GET['n'] > 0 && $_GET['n'] <= 25)
	{
		$last_n = $_GET['n'];
	}
?>
<HTML>
<HEAD>
<LINK REL="stylesheet" MEDIA="screen" TYPE="text/css" HREF="style.css" />
<TITLE>Predict problem</TITLE>
</HEAD>
<BODY>
<TABLE WIDTH="100%" HEIGHT="100%">
<TR VALIGN="TOP" HEIGHT="100%"><TD ALIGN="LEFT">

<H1>Predict problem</H1>

<FORM ACTION="predict.php" METHOD="GET">
<TABLE>
<TR><TD>Number of events to show per table:</TD><TD><SELECT NAME="n"><OPTION VALUE="1">1</OPTION><OPTION VALUE="5" SELECTED>5</OPTION><OPTION VALUE="10">10</OPTION><OPTION VALUE="15">15</OPTION><OPTION VALUE="20">20</OPTION><OPTION VALUE="25">25</OPTION></SELECT></TD></TR>
<TR><TD></TD><TD><INPUT TYPE="SUBMIT" VALUE="refresh"></TD></TR>
</TABLE>
</FORM>

Last <? print $last_n; ?> problems:
<TABLE BORDER=1>
<?
$query = "SELECT host, service, unixts FROM $db_table WHERE status_type='HARD' ORDER BY unixts DESC LIMIT $last_n";
$results = do_query($query);
$first = 1;
while($row = fetch_row($results))
{
	if ($first)
	{
		$first = 0;
		$when = $row['unixts'];
		$str_host = $row['host'];
		$str_service = $row['service'];
	}
	?><TR><TD><A HREF="descriptions_list.php?what=host&host=<? print enchttp($row['host']); ?>"><? print $row['host']; ?></A></TD><TD><A HREF="descriptions_list.php?what=set&set=<? print enchttp($row['service']); ?>"><? print $row['service']; ?></A></TD><TD><? print date('Y/m/d H:i:s', $row['unixts']); ?></TD></TR><?
}
?>
</TABLE>
<BR>

Expected problem(s) for today at <? print $hour; ?> hour:<BR>

<H2>pearson correlation</H2>
<?

# correlate an host+service combinations with an other host+service combination
# where the number of errors per hour is somewhat equal (<= pearson) for each hour
# we also look for a problem occuring at that time not equal to the most recent one

$query = "
SELECT 
	host2, service2,
	ABS((psum - (sum1 * sum2 / n)) / sqrt((sum1sq - pow(sum1, 2.0) / n) * (sum2sq - pow(sum2, 2.0) / n))) AS r,
	n
FROM
	(SELECT
		n1.host AS host1,
		n1.service AS service1,
		n2.host AS host2,
		n2.service AS service2,
		SUM(n1.count) AS sum1,
		SUM(n2.count) AS sum2,
		SUM(n1.count * n1.count) AS sum1sq,
		SUM(n2.count * n2.count) AS sum2sq,
		SUM(n1.count * n2.count) AS psum, 
		COUNT(*) AS n
	FROM
		(SELECT host, service, hour, COUNT(*) AS count FROM $db_table WHERE status_type='HARD' GROUP BY host, service, hour) AS n1,
		(SELECT host, service, hour, COUNT(*) AS count FROM $db_table WHERE status_type='HARD' GROUP BY host, service, hour) AS n2
	WHERE
		n1.hour = n2.hour AND
		n1.host = '$str_host' AND n1.service = '$str_service' AND (n2.host != '$str_host' OR n2.service != '$str_service')
	GROUP BY
		host1, service1, host2, service2) AS matching
ORDER BY
	r DESC,
	n DESC
LIMIT
	$last_n";

?>
<TABLE BORDER="1">
<TR><TD><B>host</B></TD><TD><B>service</B></TD><TD><B>correlation</B></TD><TD><B>number of<BR>matching <? print $field; ?>s</B></TD></TR>
<?
$results = do_query($query);
$tc=0;
while($row = fetch_row($results))
{
	?><TR><?
	?><TD><A HREF="descriptions_list.php?what=host&host=<? print enchttp($row['host2']); ?>"><? print $row['host2']; ?></A></TD><?
	?><TD><A HREF="descriptions_list.php?what=set&set=<? print enchttp($row['service2']); ?>"><? print $row['service2']; ?></A></TD><?
	?><TD><? print $row['r']; ?></TD><?
	?><TD><? print $row['n']; ?></TD><?
	?></TR><?

	$tc++;
}
print "</TABLE>\n";

if ($tc == 0)
{
	print "no problems expected.<BR>\n";
}
?>

<H2>most frequent events at this hour</H2>
<TABLE BORDER="1">
<?
$query = "SELECT host, service, COUNT(*) AS n FROM $db_table WHERE hour='$hour' AND status_type='HARD' GROUP BY host, service ORDER BY n DESC limit $last_n";
$results = do_query($query);
while($row = fetch_row($results))
{
	?><TR><?
	?><TD><A HREF="descriptions_list.php?what=host&host=<? print enchttp($row['host']); ?>"><? print $row['host']; ?></A></TD><?
	?><TD><A HREF="descriptions_list.php?what=set&set=<? print enchttp($row['service']); ?>"><? print $row['service']; ?></A></TD><?
	?><TD><? print $row['n']; ?></TD><?
	?></TR><?
	print "\n";
}
?>
</TABLE>

<H2>most frequent events at this day of the week</H2>
<TABLE BORDER="1">
<?
$query = "SELECT host, service, COUNT(*) AS n FROM $db_table WHERE weekday='$weekday' AND status_type='HARD' GROUP BY host, service ORDER BY n DESC limit $last_n";
$results = do_query($query);
while($row = fetch_row($results))
{
	?><TR><?
	?><TD><A HREF="descriptions_list.php?what=host&host=<? print enchttp($row['host']); ?>"><? print $row['host']; ?></A></TD><?
	?><TD><A HREF="descriptions_list.php?what=set&set=<? print enchttp($row['service']); ?>"><? print $row['service']; ?></A></TD><?
	?><TD><? print $row['n']; ?></TD><?
	?></TR><?
	print "\n";
}
?>
</TABLE>

<H2>most frequent events at this day of the month</H2>
<TABLE BORDER="1">
<?
$query = "SELECT host, service, COUNT(*) AS n FROM $db_table WHERE day='$monthday' AND status_type='HARD' GROUP BY host, service ORDER BY n DESC limit $last_n";
$results = do_query($query);
while($row = fetch_row($results))
{
	?><TR><?
	?><TD><A HREF="descriptions_list.php?what=host&host=<? print enchttp($row['host']); ?>"><? print $row['host']; ?></A></TD><?
	?><TD><A HREF="descriptions_list.php?what=set&set=<? print enchttp($row['service']); ?>"><? print $row['service']; ?></A></TD><?
	?><TD><? print $row['n']; ?></TD><?
	?></TR><?
	print "\n";
}
?>
</TABLE>

</TD></TR>
<TR><TD><? require('copyright.inc.php'); ?></TD></TR>
</TABLE>

</BODY>
</HTML>
